#include <stdio.h>

int s[96],t[96];

main(argc,argv)
int argc;
char *argv[];
{
  FILE *fp;
  int i,j;
  if(argc!=3){
    fprintf(stderr,"Usage: %s inputfile outputfile\n",argv[0]);
    exit(1);
  }
  if((fp=fopen(argv[2],"w"))==NULL){
    fprintf(stderr,"Cannot open %s\n",argv[2]);
    exit(1);
  }
  for(i=0;argv[2][i]>0;i++){
    if(argv[2][i]=='.'){
      argv[2][i]=0;
      break;
    }
  }
  fprintf(fp,"extern unsigned short nulltbl[];\n");
  for(i=1;i<95;i++){
    if(s[i]=t2c(argv[1],i)){
      fprintf(fp,"static unsigned short %s_%02d[]={\n         ",argv[2],i);
      for(j=1;j<94;j++){
	fprintf(fp,"0x%04x,",t[j]);
	if(j%8==7)
	  fprintf(fp,"\n  ");
      }
      fprintf(fp,"0x%04x\n};\n",t[94]);
    }
  }
  fprintf(fp,"unsigned short *%s[]={\n",argv[2]);
  for(i=1;i<94;i++){
    if(s[i])
      fprintf(fp,"  %s_%02d,\n",argv[2],i);
    else
      fprintf(fp,"  nulltbl,\n");
  }
  if(s[94])
    fprintf(fp,"  %s_94\n};\n",argv[2]);
  else
    fprintf(fp,"  nulltbl\n};\n");
  exit(0);
}

t2c(f,p)
char *f;
int p;
{
  FILE *fp;
  int i,j,k,l;
  for(i=0;i<96;i++)
    t[i]=0;
  if((fp=fopen(f,"r"))==NULL){
    fprintf(stderr,"Cannot open %s\n",f);
    exit(1);
  }
  while((i=fgetc(fp))>=0){
    while(i=='\n'){
      if((i=fgetc(fp))=='\n'){
	if((i=fgetc(fp))==p/10+'0'){
	  if((i=fgetc(fp))==(p%10)+'0')
	    i=256;
	}
      }
    }
    if(i==256)
      break;
  }
  if(i<0){
    fclose(fp);
    return(0);
  }
  k= -1;
  l=0;
  for(j=1;j<95;j++){
    if((i=fgetc(fp))=='\n'){
      j=(k+=20);
      l++;
    }
    else if(i<0)
      break;
    else{
      i*=256;
      if((i+=fgetc(fp))==0x2020)
	t[j]=0;
      else if(l>1&&i>0x302f&&i<0x393a&&(i&255)>='0'&&(i&255)<='9')
	break;
      else
	t[j]=i;
      l=0;
    }
  }
  fclose(fp);
  return(1);
}
